	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x1000
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x1008
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x1018
	#elif defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x800
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x808
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x818
	#else	
		#define REMAPPED_RESET_VECTOR_ADDRESS			0x00
		#define REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS	0x08
		#define REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS	0x18
	#endif
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	extern void _startup (void);        // See c018i.c in your C18 compiler dir
	
	
	#pragma code REMAPPED_RESET_VECTOR = REMAPPED_RESET_VECTOR_ADDRESS
	void _reset (void)
	{
	    _asm goto _startup _endasm
	}
	#endif
	
	
	#pragma code inth=0x08//REMAPPED_HIGH_INTERRUPT_VECTOR = REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS
	void Remapped_High_ISR (void)
	{
	     _asm goto YourHighPriorityISRCode _endasm
	}
	#pragma code intl=0x18//REMAPPED_LOW_INTERRUPT_VECTOR = REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS
	void Remapped_Low_ISR (void)
	{
	     _asm goto YourLowPriorityISRCode _endasm
	}
	
	#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_MCHPUSB_BOOTLOADER)
	//Note: If this project is built while one of the bootloaders has
	//been defined, but then the output hex file is not programmed with
	//the bootloader, addresses 0x08 and 0x18 would end up programmed with 0xFFFF.
	//As a result, if an actual interrupt was enabled and occured, the PC would jump
	//to 0x08 (or 0x18) and would begin executing "0xFFFF" (unprogrammed space).  This
	//executes as nop instructions, but the PC would eventually reach the REMAPPED_RESET_VECTOR_ADDRESS
	//(0x1000 or 0x800, depending upon bootloader), and would execute the "goto _startup".  This
	//would effective reset the application.
	
	//To fix this situation, we should always deliberately place a 
	//"goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS" at address 0x08, and a
	//"goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS" at address 0x18.  When the output
	//hex file of this project is programmed with the bootloader, these sections do not
	//get bootloaded (as they overlap the bootloader space).  If the output hex file is not
	//programmed using the bootloader, then the below goto instructions do get programmed,
	//and the hex file still works like normal.  The below section is only required to fix this
	//scenario.
	#pragma code HIGH_INTERRUPT_VECTOR = 0x08
	void High_ISR (void)
	{
	     _asm goto REMAPPED_HIGH_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#pragma code LOW_INTERRUPT_VECTOR = 0x18
	void Low_ISR (void)
	{
	     _asm goto REMAPPED_LOW_INTERRUPT_VECTOR_ADDRESS _endasm
	}
	#endif	//end of "#if defined(PROGRAMMABLE_WITH_USB_HID_BOOTLOADER)||defined(PROGRAMMABLE_WITH_USB_LEGACY_CUSTOM_CLASS_BOOTLOADER)"

	#pragma code
	
	
	//These are your actual interrupt handling routines.
	#pragma interrupt YourHighPriorityISRCode

void YourHighPriorityISRCode()
	{
		
	DataReceived();

      #if defined(USB_INTERRUPT)
	        USBDeviceTasks();
        #endif
}	//This return will be a "retfie fast", since this is in a #pragma interrupt section 


#pragma interruptlow YourLowPriorityISRCode

void YourLowPriorityISRCode()
	{
#if defined(__18F4550)

TestVar--;
if(TestVar == 0)
{
	TestVar=6;	
	CycleTimer--;
}


	PWMPeriod++;
	if(PWMPeriod != 255)
	{
		
	if(RedVal[7]>0)
	{
	RedVal[7]--;
	T22=1;
	}
	else {
	T22=0;
	}

	if(GreenVal[7]>0)
	{
	GreenVal[7]--;
	T23=1;
	}
	else {
	T23=0;
	}
	
	if(BlueVal[7]>0) {
	BlueVal[7]--;
	T24=1;
	}
	else {
	T24=0;
	}
	
//==============NEXT LED
	if(RedVal[6]>0)
	{
	RedVal[6]--;
	T19=1;
	}
	else {
	T19=0;
	}

	if(GreenVal[6]>0)
	{
	GreenVal[6]--;
	T20=1;
	}
	else {
	T20=0;
	}
	
	if(BlueVal[6]>0) {
	BlueVal[6]--;
	T21=1;
	}
	else {
	T21=0;
	}
	
//NEXT LED==========

	if(RedVal[5]>0)
	{
	RedVal[5]--;
	T16=1;
	}
	else {
	T16=0;
	}

	if(GreenVal[5]>0)
	{
	GreenVal[5]--;
	T17=1;
	}
	else {
	T17=0;
	}
	
	if(BlueVal[5]>0) {
	BlueVal[5]--;
	T18=1;
	}
	else {
	T18=0;
	}

//NEXT LED==========
	if(RedVal[4]>0)
	{
	RedVal[4]--;
	T13=1;
	}
	else {
	T13=0;
	}

	if(GreenVal[4]>0)
	{
	GreenVal[4]--;
	T14=1;
	}
	else {
	T14=0;
	}
	
	if(BlueVal[4]>0) {
	BlueVal[4]--;
	T15=1;
	}
	else {
	T15=0;
	}
//NEXT LED==========
	if(RedVal[3]>0)
	{
	RedVal[3]--;
	T10=1;
	}
	else {
	T10=0;
	}

	if(GreenVal[3]>0)
	{
	GreenVal[3]--;
	T11=1;
	}
	else {
	T11=0;
	}
	
	if(BlueVal[3]>0) {
	BlueVal[3]--;
	T12=1;
	}
	else {
	T12=0;
	}
//NEXT LED==========
	if(RedVal[2]>0)
	{
	RedVal[2]--;
	T7=1;
	}
	else {
	T7=0;
	}

	if(GreenVal[2]>0)
	{
	GreenVal[2]--;
	T8=1;
	}
	else {
	T8=0;
	}
	
	if(BlueVal[2]>0) {
	BlueVal[2]--;
	T9=1;
	}
	else {
	T9=0;
	}
//NEXT LED==========
	if(RedVal[1]>0)
	{
	RedVal[1]--;
	T4=1;
	}
	else {
	T4=0;
	}

	if(GreenVal[1]>0)
	{
	GreenVal[1]--;
	T5=1;
	}
	else {
	T5=0;
	}
	
	if(BlueVal[1]>0) {
	BlueVal[1]--;
	T6=1;
	}
	else {
	T6=0;
	}
//NEXT LED==========
	if(RedVal[0]>0)
	{
	RedVal[0]--;
	T1=1;
	}
	else {
	T1=0;
	}

	if(GreenVal[0]>0)
	{
	GreenVal[0]--;
	T2=1;
	}
	else {
	T2=0;
	}
	
	if(BlueVal[0]>0) {
	BlueVal[0]--;
	T3=1;
	}
	else {
	T3=0;
	}	
}
else {
	PWMPeriod=0;

	for(x=0;x != LEDTotal;x++)
	{
		RedVal[x] = RedHoldVal[x] ;
		GreenVal[x] = GreenHoldVal[x];
		BlueVal[x] = BlueHoldVal[x];
	}
}
	INTCONbits.TMR0IF=0;
	TMR2=0;
	PIR1bits.TMR2IF=0;

//PWM Freq: 251 @ PR2=1; 114  @ PR2= 50

#elif defined(__18F2550)

	if (INTCONbits.TMR0IF) //uses TMR0 as timing source
	{
	CycleTimer--;		
	XLATinterrupt();
	INTCONbits.TMR0IF = 0;// Clear the timer0 interrupt flag
	INTCONbits.GIEL = 1;
	}

#endif
	}	//This return will be a "retfie", since this is in a #pragma interruptlow section 


void DataDump(unsigned char Type)
{

switch(Type)
{
case 1:
	if(USBUSARTIsTxTrfReady()) putUSBUSART(SlideBytes, 8);
	break;
case 2:
	for(x=0;x != 12;x++)
	{
	SendArray[x]=RefID[x];
	}
	if(USBUSARTIsTxTrfReady()) putUSBUSART(SendArray, 12);
	break;
case 3:
	SendArray[0]=123;
	SendArray[1]=MaxSettings;
	SendArray[2]= SetNumber;
	SendArray[3]= SetSelection;
	if(USBUSARTIsTxTrfReady()) putUSBUSART(SendArray, 4);
	break;
case 4:
	for(x=0;x != 8;x++)
	{
	SendArray[x]=MultiPattern[x];
	}

	if(USBUSARTIsTxTrfReady()) putUSBUSART(SendArray, 8);
	break;	
case 5:
	if(USBUSARTIsTxTrfReady()) putUSBUSART(MultiCounter, 8);
	break;		
}


/*
	SendArray[0]=FrameAmount;
	SendArray[1]=FrameNumber;
	SendArray[2]=MultiNext;
	SendArray[3]=Mode;
	if(USBUSARTIsTxTrfReady()) putUSBUSART(SendArray, 4);
*/


}//end function


void RedCycle(unsigned char led,unsigned char dir)
{
	if(dir==0)//If Down
	{
	if(RedHoldVal[led] <= CurrentFrameREnd)
	{
	bsf(RedFlags.asByte,led);
	}
	else {
		CycleFactorR[led]=(float)CycleFactorR[led]+(float)FloatRFactor[led];
		if((float)CycleFactorR[led] > 1)
		{
		CycleFactorR[led]=(float)CycleFactorR[led]-1;
		RedHoldVal[led]--;
		}
		else return;
	}
	}
	else {
	if(RedHoldVal[led] >= CurrentFrameREnd)
	{
	bsf(RedFlags.asByte,led);
	}
	else {
		CycleFactorR[led]=(float)CycleFactorR[led]+(float)FloatRFactor[led];
		if((float)CycleFactorR[led] >= 1)
		{
		CycleFactorR[led]=(float)CycleFactorR[led]-1;
		RedHoldVal[led]++;
		}
		else return;
	}
	}
}



void GreenCycle(unsigned char led,unsigned char dir)
{
	if(dir==0)//If Down
	{
	if(GreenHoldVal[led] <= CurrentFrameGEnd)
	{
	bsf(GreenFlags.asByte,led);
	}
	else {
		CycleFactorG[led]=(float)CycleFactorG[led]+(float)FloatGFactor[led];
		if((float)CycleFactorG[led] >= 1)
		{
		CycleFactorG[led]=(float)CycleFactorG[led]-1;
		GreenHoldVal[led]--;
		}
		else return;
	}
	}
	else {
	if(GreenHoldVal[led] >= CurrentFrameGEnd)
	{
	bsf(GreenFlags.asByte,led);
	}
	else {
		CycleFactorG[led]=(float)CycleFactorG[led]+(float)FloatGFactor[led];
		if((float)CycleFactorG[led] >= 1)
		{
		CycleFactorG[led]=(float)CycleFactorG[led]-1;
		GreenHoldVal[led]++;
		}
		else return;
	}
	}
}


void BlueCycle(unsigned char led,unsigned char dir)
{
	if(dir==0)//If Down
	{
		if(BlueHoldVal[led] <= CurrentFrameBEnd)
		{
		bsf(BlueFlags.asByte,led);
		}
	else {
		CycleFactorB[led]=(float)CycleFactorB[led]+(float)FloatBFactor[led];
		if((float)CycleFactorB[led] >= 1)
		{
		CycleFactorB[led]=(float)CycleFactorB[led]-1;
		BlueHoldVal[led]--;
		}
		else return;
	}
	}
	else {
		if(BlueHoldVal[led] >= CurrentFrameBEnd)
		{
		bsf(BlueFlags.asByte,led);
		}
	else {
		CycleFactorB[led]=(float)CycleFactorB[led]+(float)FloatBFactor[led];
		if((float)CycleFactorB[led] >= 1)
		{
		CycleFactorB[led]=(float)CycleFactorB[led]-1;
		BlueHoldVal[led]++;
		}
		else return;
		}
	}
}


void DataReceived(void)
{
	NewBuffer=input_buffer[0]; //move new byte into buffer

//send request byte -> rec acknowledge ->  send confirm -> rec confirm ->send command -> send data amount -> send data
//send Q -> Rec N -> send q -> rec n ->send BYTE(BYTE is converted to action) - > send data1-> - > send data2

//NewBuffer -> Buffer1 -> Buffer2 -> Buffer3

//host sends to device -> q -> Q -> z -> device sends N -> host responds with G -> device sends n -> Host sends -> Command -> data1 -> data2

if(DataConfirm == 0) //dataconfirm is set after proper character exchanges
{
if(NewBuffer == 'z' && Buffer1== 'Q' && Buffer2 =='q')
{
if(mUSBUSARTIsTxTrfReady()) putrsUSBUSART("N");
}
else if(NewBuffer == 'G' && Buffer1== 'z' && Buffer2 =='Q' && Buffer3 =='q')
{
if(mUSBUSARTIsTxTrfReady()) putrsUSBUSART("n");
DataConfirm=1;
}
}//end dataconfirm if
else {
//if it gets here the next byte is the command byte
//but it skips 3 bytes, on the 3rd byte(data2) it will run the checks

DataSkip++;

if(DataSkip==3)
{
DataSkip=0;

//Buffer2 is the oldest byte, and is the command byte,
//Buffer1 is data1
//USBbuffer is data2

DemoMode=0;
MultiFlag=0;

switch(Buffer2)
{
case 1: //upload Settings
	DataConfirm = 0;
	
//	if(Buffer1 == 123 && NewBuffer==69) {	//used for demo mode
	Mode=mStall;
	uploadRollover=13; //should be 13 but 14 because of the bug
	uploadCounter=0;
	Flag1=1;//used to discard current byte and start using the next ones
	FlagSettingUpload=1;
	SettingsFirst=0;
	SettingC=0;
	DataPart=0;
//	}
	
	
	break;

case 3: //datadump
	DataConfirm = 0;
	DataDump(Buffer1);
	break;

case 4: //connect device
		uploadCounter=0;
		//send Device Data
		SendArray[0]=HardwareID;
		SendArray[1]=FirmwareV;
		putUSBUSART(SendArray, 2);
		
		ResetFlags();		
		Flags.asByte=0x00;
		Flags2.asByte=0x00;	
		Flags3.asByte=0x00;
	//	Flags4.asByte=0x00;
	
if(Mode==mLive) ChangeFlag=1;
	
		DataSkip=0;
	break;
case 100: //Multi-Upload
//make and set flag for uploading, run from if(fillDataarrays==1)
//Upload Multi runs from PC first, followed by normal upload of settings.
	DataConfirm = 0;
	uploadRollover=64;
	uploadCounter=0;
	
	SetMultiFlag=0;
	MultiFlag=0;
	
	MultiUploadFlag=1;
	Flag1=1;//used to discard current byte and start using the next ones
	break;
case 200: //reset
	DataConfirm = 0;
	FlagPauseCycle =0;
	FlagCmdUpload = 0;
	LiveMode =0;
	ResetFlags();
	break;
case 220: //Pattern Change, data1(what ones) data1=value
	DataConfirm = 0;
	ResetFlags();
	FlagCmdPatternNum=1;
	break;
case 60: //Set LiveMode
	DataConfirm = 0;
	
	if(Mode == mLive)
	{
	SetMultiFlag=0;
	MultiFlag=0;
	ChangeFlag=1;
	}
	else	
	{	
	Mode = mLive;
	Flag1=1; //WAS FLAG 2 - used to discard current byte and start using the next ones
	WasLive=1;
	FlagCmdUpload = 0;
#if defined(__18F4550)
	PR2=20;
	uploadRollover = 24;
#elif defined(__18F2550)
	uploadRollover = 48;
#endif				
	uploadCounter=0;
	}
	break;	
case 70: //Solid Frames/Flash
	DataConfirm = 0;
	DataPart=0;
	SetNumber=Buffer1;

	tempType=NewBuffer; //max dataparts
	tempMode=mFlash; //sets this so functions can run before setting the final Mode

	uploadRollover=64;//72; //24 bytes per frame, 8 frames + 8 speed bytes
	uploadCounter=0;
	Flag1=1;//used to discard current byte and start using the next ones
	break;		
case 80: //Demo Pattern Upload
	DataConfirm = 0;
	Mode=mStall;
	uploadRollover=64;
	uploadCounter=0;
	SettingC=0;
	DataPart=0;
	tempMode=mCycle;
	DemoUpload=1;

	SetMultiFlag=0;
	MultiFlag=0;

	Flag1=1;//used to discard current byte and start using the next ones
	break;
case 85: //Flash Demo Upload
	DataConfirm = 0;
	Mode=mStall;
	uploadRollover=64;
	uploadCounter=0;
	SettingC=0;
	DataPart=0;
	tempMode=mFlash;
	DemoUpload=1;

	Flag1=1;//used to discard current byte and start using the next ones
	break;

case 123: //HARDWARE RESET - after dealy, it resets the device
	HardReset();
	break;

case 90://Software Setting Down
	DataConfirm = 0;
	if(SetNumber > 0) SetNumber--;
	else SetNumber=MaxSettings;

	ChangeFlag=1;
	break;

case 91: //Software Setting Up
	DataConfirm = 0;
	if(SetNumber < MaxSettings) SetNumber++;
	else SetNumber=0;

	ChangeFlag=1;
	break;

}//switch
}//if
}//else

	if(FlagCmdUpload == 1 && FillArrays == 0)
	{  
		uploadStr[uploadCounter]=NewBuffer;
		uploadCounter++;
		//if set to 64, then 64 bytes are collected. final value is not used....
		if(uploadCounter == uploadRollover)
		{		
		uploadCounter=0;
		FillArrays=1;
		}//end uploadcounter if		
	}

	if(Flag1==1)//waits till next data byte to start filling the buffer array
	{
	FlagCmdUpload=1;
	Flag1=0;
	}

	Buffer3=Buffer2;
	Buffer2=Buffer1;
	Buffer1=NewBuffer;	
} //end function
